=== debian/changelog ===
hart-software-services (2022.10-0ubuntu1~22.04.1) jammy-security; urgency=medium

  * No-change rebuild for -security pocket.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 28 Nov 2022 08:19:19 -0500

hart-software-services (2022.10-0ubuntu1~22.04) jammy; urgency=medium

  * Backport to jammy for hardware enablement (LP: #1997035)
  * Use new upstream release. All our patches are included. (LP: #1993528)
    We only package the payload generator which has the following upstream
    release changes:
    - ability added to override context boot image name in YAML
    - deprecated OpenSSL APIs replaced by current API

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Fri, 28 Oct 2022 14:13:48 +0200
