=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --sourcedirectory=tools/hss-payload-generator
