=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.xz/hart-software-services-$1\.tar\.xz/ \
  https://github.com/polarfire-soc/hart-software-services/tags .*/v?(\d\S+)\.tar\.gz
